Automate installation of DXVK, D9VK + Wine/Wine Staging & update GPU drivers + PlayonLinux wineprefixes (Debian/Ubuntu/Mint/Arch Linux/Manjaro)
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

412 lines
11 KiB

6 years ago
6 years ago
2 years ago
2 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
6 years ago
  1. #!/bin/env bash
  2. # DXVK/Wine-Staging scripts dispatcher for various Linux distributions
  3. # Copyright (C) 2019 Pekka Helenius
  4. #
  5. # This program is free software: you can redistribute it and/or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation, either version 3 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  17. ##############################################################################
  18. source options.conf
  19. ###########################################################
  20. # Check if we're using bash or sh to run the script. If bash, OK.
  21. # If another one, ask user to run the script with bash.
  22. BASH_CHECK=$(ps | grep `echo $$` | awk '{ print $4 }')
  23. if [ $BASH_CHECK != "bash" ]; then
  24. echo "
  25. Please run this script using bash (/usr/bin/bash).
  26. "
  27. exit 1
  28. fi
  29. ###########################################################
  30. # Just a title & author for this script, used in initialization and help page
  31. SCRIPT_TITLE="\e[1mWine/Wine Staging & DXVK package builder & auto-installer\e[0m"
  32. SCRIPT_AUTHOR="Pekka Helenius (~Fincer), 2019"
  33. ###########################################################
  34. # Allow interruption of the script at any time (Ctrl + C)
  35. trap "exit" INT
  36. ###########################################################
  37. COMMANDS=(
  38. curl
  39. date
  40. df
  41. find
  42. git
  43. grep
  44. groups
  45. nproc
  46. patch
  47. readlink
  48. sudo
  49. tar
  50. uname
  51. wc
  52. wget
  53. )
  54. SUDO_GROUPS=(
  55. sudo
  56. wheel
  57. )
  58. function checkCommands() {
  59. local COMMANDS_NOTFOUND
  60. local a
  61. if [[ $(which --help 2>/dev/null) ]] && [[ $(echo --help 2>/dev/null) ]]; then
  62. a=0
  63. for command in ${@}; do
  64. if [[ ! $(which $command 2>/dev/null) ]]; then
  65. COMMANDS_NOTFOUND[$a]=${command}
  66. let a++
  67. fi
  68. done
  69. if [[ -n $COMMANDS_NOTFOUND ]]; then
  70. echo -e "\nError! The following commands could not be found: ${COMMANDS_NOTFOUND[*]}\nAborting\n"
  71. exit 1
  72. fi
  73. else
  74. exit 1
  75. fi
  76. }
  77. checkCommands "${COMMANDS[*]}"
  78. ###########################################################
  79. # http://wiki.bash-hackers.org/snipplets/print_horizontal_line#a_line_across_the_entire_width_of_the_terminal
  80. function INFO_SEP() { printf '%*s\n' "${COLUMNS:-$(tput cols)}" '' | tr ' ' - ; }
  81. ###########################################################
  82. if [[ $(uname -a | grep -c x86_64) -eq 0 ]]; then
  83. echo "This script supports 64-bit architectures only."
  84. exit 1
  85. fi
  86. if [[ $(groups | grep -cE $(echo ${SUDO_GROUPS[*]} | sed 's/ /|/g')) -eq 0 ]]; then
  87. echo "You must belong to a sudo group (checked groups: ${SUDO_GROUPS[*]})."
  88. exit 1
  89. fi
  90. unset sudogrp
  91. if [[ $UID -eq 0 ]]; then
  92. echo "Run as a regular user."
  93. exit 1
  94. fi
  95. ###########################################################
  96. # User-passed arguments for the script
  97. # We check the values of this array
  98. # and pass them to the subscripts if supported
  99. i=0
  100. for arg in ${@}; do
  101. case ${arg} in
  102. --no-staging)
  103. # Do not build Wine staging version, just Wine
  104. ;;
  105. --no-install)
  106. # Just build, do not install DXVK or Wine-Staging
  107. # Note that some version of Wine is required for DXVK compilation, though!
  108. ;;
  109. --no-wine)
  110. # Skip Wine build & installation process all together
  111. NO_WINE=
  112. ;;
  113. --no-dxvk)
  114. # Skip DXVK build & installation process all together
  115. NO_DXVK=
  116. ;;
  117. --no-vkd3d)
  118. # Skip VKD3D Proton build & installation process all together
  119. NO_VKD3D=
  120. ;;
  121. --no-pol)
  122. # Skip PlayOnLinux Wine prefixes update process
  123. ;;
  124. *)
  125. echo -e "\n\
  126. \
  127. ${SCRIPT_TITLE} by ${SCRIPT_AUTHOR}\n\n\
  128. Usage:\n\nbash updatewine.sh\n\nArguments:\n\n\
  129. --no-install\tDo not install Wine or DXVK. Just compile them. Wine, meson & glslang must be installed for DXVK compilation.\n\
  130. --no-dxvk\tDo not compile or install DXVK\n\
  131. --no-vkd3d\tDo not compile or install VKD3D Proton\n\
  132. --no-pol\tDo not update PlayOnLinux Wine prefixes\n\n\
  133. --no-staging\tCompile Wine instead of Wine Staging\n\
  134. --no-wine\tDo not compile or install Wine/Wine Staging\n\n\
  135. Compiled packages are installed by default, unless '--no-install' argument is given.\n\
  136. If '--no-install' argument is given, the script doesn't check or update your PlayOnLinux Wine prefixes.\n"
  137. exit 0
  138. ;;
  139. esac
  140. args[$i]="${arg}"
  141. let i++
  142. done
  143. ###########################################################
  144. # Date timestamp and random number identifier for compiled
  145. # DXVK & Wine Staging builds
  146. # This variable is known as 'datedir' in other script files
  147. datesuffix=$(echo $(date '+%Y-%m-%d-%H%M%S'))
  148. ###########################################################
  149. # Add git commit hash overrides to argument list
  150. # Pass them to subscripts, as well.
  151. githash_overrides=(
  152. "${git_commithash_vkd3dproton}" # 0
  153. "${git_commithash_dxvk}" # 1
  154. "${git_commithash_glslang}" # 2
  155. "${git_commithash_meson}" # 3
  156. "${git_commithash_wine}" # 4
  157. )
  158. # Add git branches to argument list
  159. # Pass them to subscripts, as well.
  160. gitbranch_overrides=(
  161. "${git_branch_vkd3dproton}" # 5
  162. "${git_branch_dxvk}" # 6
  163. "${git_branch_glslang}" # 7
  164. "${git_branch_meson}" # 8
  165. "${git_branch_wine}" # 9
  166. )
  167. # Add git sources to argument list
  168. # Pass them to subscripts, as well.
  169. gitsources=(
  170. "${git_source_vkd3dproton}" # 10
  171. "${git_source_dxvk}" # 11
  172. "${git_source_glslang}" # 12
  173. "${git_source_meson}" # 13
  174. "${git_source_wine}" # 14
  175. "${git_source_winestaging}" # 15
  176. )
  177. #############################
  178. # Commit syntax validity check
  179. for githash in ${githash_overrides[@]}; do
  180. if [[ ! $(printf ${githash} | wc -c) -eq 40 ]] && \
  181. [[ ! ${githash} == HEAD ]]; then
  182. echo -e "\nError: badly formatted commit hash '${githash}' in the script file 'updatewine.sh'. Aborting\n"
  183. exit 1
  184. fi
  185. done
  186. ###########################################################
  187. params=(${datesuffix} ${githash_overrides[@]} ${gitbranch_overrides[@]} ${gitsources[@]} ${args[@]})
  188. ###########################################################
  189. # General function for question responses
  190. function questionresponse() {
  191. local response=${1}
  192. read -r -p "" response
  193. if [[ $(echo $response | sed 's/ //g') =~ ^([yY][eE][sS]|[yY])$ ]]; then
  194. echo ""
  195. return 0
  196. else
  197. return 1
  198. fi
  199. }
  200. ###########################################################
  201. function reqsCheck() {
  202. local AVAIL_SPACE
  203. local REC_SPACE
  204. local MSG_SPACE
  205. local AVAIL_RAM
  206. local REC_RAM
  207. local MSG_RAM
  208. AVAIL_SPACE=$(df -h -B MB --output=avail . | sed '1d; s/[A-Z]*//g')
  209. REC_SPACE=8000
  210. MSG_SPACE="\e[1mWARNING:\e[0m Not sufficient storage space\n\nYou will possibly run out of space while compiling software.\n\
  211. The script strongly recommends ~\e[1m$((${REC_SPACE} / 1000)) GB\e[0m at least to compile software successfully but you have only\n\
  212. \e[1m${AVAIL_SPACE} MB\e[0m left on the filesystem the script is currently placed at.\n\n\
  213. Be aware that the script process may fail because of this, especially while compiling Wine Staging.\n\n\
  214. Do you really want to continue? [Y/n]"
  215. AVAIL_RAM=$(( $(grep -oP "(?<=^MemFree:).*[0-9]" /proc/meminfo | sed 's/ //g') / 1024 ))
  216. REC_RAM=4096
  217. MSG_RAM="\e[1mWARNING:\e[0m Not sufficient RAM available\n\nCompilation processes will likely fail.\n\
  218. The script strongly recommends ~\e[1m${REC_RAM} MB\e[0m at least to compile software successfully but you have only\n\
  219. \e[1m${AVAIL_RAM} MB\e[0m left on the computer the script is currently placed at.\n\n\
  220. Be aware that the script process may fail because of this, especially while compiling DXVK.\n\n\
  221. Do you really want to continue? [Y/n]"
  222. function reqs_property() {
  223. local avail_prop
  224. local req_prop
  225. local req_message
  226. local req_installtargets
  227. local req_targetconditions
  228. local fullcondition
  229. local i
  230. avail_prop="${1}"
  231. req_prop="${2}"
  232. req_message="${3}"
  233. req_installtargets="${4}"
  234. i=0
  235. for req_installtarget in ${req_installtargets}; do
  236. req_targetconditions[$i]=$(echo "[[ ! -v ${req_installtarget} ]] ||")
  237. let i++
  238. done
  239. req_targetconditions=($(echo ${req_targetconditions[@]} | sed 's/\(.*\) ||/\1 /'))
  240. fullcondition="[[ "${avail_prop}" -lt "${req_prop}" ]] && ($(echo ${req_targetconditions[@]}))"
  241. if $(eval ${fullcondition}); then
  242. INFO_SEP
  243. echo -e "${req_message}"
  244. questionresponse
  245. if [[ $? -ne 0 ]]; then
  246. echo -e "Cancelling.\n"
  247. exit 1
  248. fi
  249. unset avail_prop req_prop req_installtarget req_targetconditions fullcondition
  250. fi
  251. }
  252. reqs_property "${AVAIL_SPACE}" "${REC_SPACE}" "${MSG_SPACE}" "NO_WINE"
  253. reqs_property "${AVAIL_RAM}" "${REC_RAM}" "${MSG_RAM}" "NO_DXVK"
  254. }
  255. ###########################################################
  256. function sudoQuestion() {
  257. sudo -k
  258. echo -e "\e[1mINFO:\e[0m sudo password required\n\nThis script requires elevated permissions for package updates & installations. Please provide your sudo password for these script commands. Sudo permissions are not used for any other purposes.\n"
  259. sudo -v
  260. if [[ $? -ne 0 ]]; then
  261. echo -e "Invalid sudo password.\n"
  262. exit 1
  263. fi
  264. # PID of the current main process
  265. PIDOF=$$
  266. # Run sudo timestamp update on the background and continue the script execution
  267. # Refresh sudo timestamp while the main process is running
  268. function sudo_refresh() {
  269. while [[ $(printf $(ps ax -o pid --no-headers | grep -o ${PIDOF} &> /dev/null)$?) -eq 0 ]]; do
  270. sudo -nv && sleep 2
  271. done
  272. }
  273. sudo_refresh &
  274. }
  275. ###########################################################
  276. function checkInternet() {
  277. if [[ $(echo $(wget --delete-after -q -T 5 github.com -o -)$?) -ne 0 ]]; then
  278. echo -e "\nDNS name resolution failed (GitHub). Please check your network connection settings and try again.\n"
  279. exit 1
  280. fi
  281. rm -f ./index.html.tmp
  282. }
  283. checkInternet
  284. ###########################################################
  285. # Only Debian & Arch based Linux distributions are currently supported
  286. function determineDistroFamily() {
  287. # These are default package managers used by the supported Linux distributions
  288. pkgmgrs=('dpkg' 'pacman')
  289. for pkgmgr in ${pkgmgrs[@]}; do
  290. if [[ $(printf $(which ${pkgmgr} &> /dev/null)$?) -eq 0 ]]; then
  291. pkgmgr_valid=${pkgmgr}
  292. fi
  293. done
  294. case ${pkgmgr_valid} in
  295. dpkg)
  296. distro="debian"
  297. ;;
  298. pacman)
  299. distro="arch"
  300. ;;
  301. default|*)
  302. echo -e "Your Linux distribution is not supported. Aborting.\n"
  303. exit 1
  304. ;;
  305. esac
  306. }
  307. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]] || [[ ! -v NO_VKD3D ]]; then
  308. echo -e "\n${SCRIPT_TITLE}\n\nBuild identifier:\t${datesuffix}\n"
  309. else
  310. echo ""
  311. fi
  312. if [[ -n ${args[*]} ]]; then
  313. echo -e "Using arguments:\t${args[*]}\n"
  314. fi
  315. determineDistroFamily
  316. INFO_SEP
  317. echo -e "\e[1mNOTE: \e[0mDXVK requires very latest Nvidia/AMD drivers to work.\nMake sure these drivers are available on your Linux distribution.\n\
  318. This script comes with GPU driver installation scripts for Debian-based Linux distributions.\n"
  319. INFO_SEP
  320. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]|| [[ ! -v NO_VKD3D ]]; then
  321. reqsCheck
  322. sudoQuestion
  323. echo ""
  324. fi
  325. bash -c "cd ${distro} && bash ./updatewine_${distro}.sh ${params[*]}"